/* "testrle"
 * Copyright 2001-2009 Jetro Lauha
 *
 * Test/example code to unpack embedded array packed by "binsorle".
 * Usage: Pack a (smallish) data file with the following command.
 *   binsorle FILE.EXT testrle.inc testrledata
 * Compile this source file, and run. "testrle.out" is written, which
 * should match the original file (FILE.EXT).
 *
 * Note that the code has been written no later than 2001 (possibly
 * even earlier than that), and hasn't been really "stress tested"
 * to be bug-free. Any bug reports are still welcome, of course.
 *
 * My home page / blog URL:
 *   http://jet.ro
 *
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software. If you use this software
 *    in a product, an acknowledgment in the product documentation would be
 *    appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 * $Id: testrle.c 94 2009-11-09 19:56:36Z tonic $
 * $Revision: 94 $
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <conio.h>

#include "testrle.inc"


#define u8 unsigned char

static u8 *data = testrledata;
static long datasize = sizeof(testrledata);


int main(int argc, char *argv[])
{
    FILE *fp;
    long a, o, c, size;
    u8 b;

    fp = fopen("testrle.out", "wb");

    size = *(unsigned long *)data;
    o = 4;
    while (o < datasize)
    {
        b = data[o++];
        if (b > 0)
        {
            fwrite(&b, 1, 1, fp);
        } else {
            b = data[o++];
            if (b == 0)
            {
                fwrite(&b, 1, 1, fp);
            } else {
                c = b + 1;
                b = data[o++];
                for (a = 0; a < c; ++a)
                    fwrite(&b, 1, 1, fp);
            }
        }
    }

    printf("Expected size: %d\n", size);
    printf("Output size:   %d\n", ftell(fp));

    fclose(fp);
    
    return EXIT_SUCCESS;
}

